<template>
    <div>
        <crumbs title="模板维护">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="模板名称：">
                    <el-input size="mini" v-model="filter.name" placeholder="模板名称" clearable></el-input>
                </el-form-item>
                <el-form-item label="归属：">
                    <el-select size="mini" v-model="filter.type"  placeholder="归属" clearable>
                        <el-option v-if="item.val!=6&&item.val!=7&&item.val!=8&&item.val!=9&&item.val!=10&&item.val!=21&&item.val!=22" v-for="item in Adscriptions" :label="item.name" :value="item.val" :key="item.id" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="类型：">
                    <el-select size="mini" v-model="filter.moduleType" placeholder="类型" clearable>
                        <el-option v-for="item in tagTypes" :label="item.name" :value="item.val" :key="item.id"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="归属科室：" v-if="filter.moduleType==1">
                    <el-select size="mini" v-model="filter.relationId"  placeholder="归属" clearable>
                        <el-option v-for="item in deptList" :label="item.name" :value="item.conceptId" :key="item.conceptId" ></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <el-button size="mini" type="warning" @click="addModule">添加模板</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table
                    :data="list"
                    border
                    style="width: 100%">
                <el-table-column
                        :resizable = "false"
                        type="index"
                        :index = 'indexMethod'
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="gmtModified"
                        label="操作时间"
                        width="180">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="name"
                        label="模板名称">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="ascriptionName"
                        label="模板归属"
                        width="80">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="moduleTypeName"
                        label="模板类型">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="relationName"
                        label="归属科室">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="userName"
                        label="操作人"
                        width="120">
                </el-table-column>
                <el-table-column
                        :resizable = "false"
                        prop="operate"
                        label="操作"
                        width="120">
                    <template slot-scope="scope">
                        <el-button  @click="modifyModule(scope.row)" type="text" size="small">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button @click="showDelDialog(scope.row)" class="delete" type="text" size="small">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>
    </div>
</template>

<script>
  import api from '@api/preTreat.js';

  export default {
    name: 'QuestionModules',
    data: function() {
      return {
        list: [],
        tagTypes: [],
        searched:false,
        Adscriptions: [],
        deptList:[],
        filter: {
          name: '', //模板名称
          type: '', //模板归属
          moduleType: '', //模板类型
          relationId:'',  //归属科室
        },
        currentPage: 1,
        pageSize: 10,
        total: 0,
      }
    },
    created() {
      this.getDropList();
    },
    watch:{
      'filter':{
        handler:function(){
          this.searched = false;
        },
        deep:true
      }
    },
    beforeRouteEnter(to, from, next){
      next(vm => {
        //const pm = to.param;
        Object.assign(vm,to.params);
      })
    },
    methods: {
      getDropList() {
        api.getPreTypeList().then((res) =>{
          this.getDataList();
          if(res.data.code === '0') {
            this.Adscriptions = res.data.data[1];
            this.tagTypes =  res.data.data[4];
          }
        });
        this.getDeptList();
      },
      getDeptList(){
        const depts = localStorage.getItem("precDeptList");
        const list = depts?JSON.parse(depts):[];
        if(list&&list.length>0){
          this.deptList = list;
          return ;
        }
        api.getDeptList({moduleType:0,type:1}).then((res) =>{
          if(res.data.code === '0') {
            this.deptList = res.data.data&&res.data.data.deptDTOS||[];
            localStorage.setItem("precDeptList",JSON.stringify(this.deptList));
          }
        });
      },
      getDataList(isTurnPage) {
        const param = this.getFilterItems(isTurnPage);
        this.searched = true;
        api.getModuleList(param).then((res) => {
          if (res.data.code === '0') {
            const list = res.data.data&&res.data.data.records?[...res.data.data.records]:[];
            for (var i = 0; i < list.length; i++) {
              for (var j =  0; j < this.tagTypes.length; j++) {
                if(list[i].moduleType == this.tagTypes[j].val) {
                  list[i].tagTypeCn = this.tagTypes[j].name;
                }
              }
              //后台数据typeCn转换为筛选中对应的字段名称
              for (var z =  0; z < this.Adscriptions.length; z++) {
                if(list[i].type == this.Adscriptions[z].val) {
                  list[i].typeCn = this.Adscriptions[z].name;
                }
              }
            }
            this.list = list;
            this.total = res.data.data.total;
          }else{
            this.$message({
              message: res.data.msg,
              type: 'warning'
            });
          }

        })
      },
      filterDatas() {
        this.currentPage = 1;
        this.getDataList();
      },
      addModule() {
        const pam = this.searched?{currentPage:this.currentPage,
          filter:this.filter}:{currentPage:this.currentPage};
        this.$router.push({name:'AddQuestionModules',
          params:pam});
      },
      modifyModule(row) {
        api.getModuleDetail({moduleId:row.id,type:row.type}).then((res)=>{
          const {code,data,msg} = res.data;
          if(code=='0'){
            const item = Object.assign({},row,data);
            const pam = this.searched?{currentPage:this.currentPage,
              filter:this.filter}:{currentPage:this.currentPage};
            this.$router.push({name:'AddQuestionModules',params:Object.assign(pam,{isEdit:true,data:item})});
          }else{
            this.$message({
              message: msg,
              type: 'warning'
            });
          }
        });
      },
      currentChange(next) {
        this.currentPage = next;
        this.getDataList(true);
      },
      getFilterItems(isTurnPage) {
        //翻页时筛选条件没点确定则清空
        if(isTurnPage&&!this.searched){
          this.filter = {
            name: '', //模板名称
            type: '', //模板归属
            moduleType: '', //模板类型
            relationId:'',  //归属科室
          }
        };
        const param = {
          name: this.filter.name,
          type:this.filter.type,
          moduleType: this.filter.moduleType,
          relationId: this.filter.moduleType==1?this.filter.relationId:'',
          current: this.currentPage,
          size: this.pageSize,
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      getTagType(val) {
        return val
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(row){
        const param = {
          "ids": row.id,
        };
        this.showConfirmDialog('是否删除该模板？',()=>{
          api.delModule(param).then((res)=>{
            if(res.data.code=='0'){
              if(!this.searched){
                //未点确认时清空搜索条件
                this.filter={
                  name: '', //模板名称
                  type: '', //模板归属
                  moduleType: '', //模板类型
                  relationId:'',  //归属科室
                };
              }
              if(this.list.length==1){
                //当前在最后一页且只有一条数据时，删除后跳到前一页
                this.currentPage = this.currentPage===1?1:this.currentPage-1;
              }
              this.getDataList();
              this.warning(res.data.msg || '操作成功','success');
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      }
    }
  }
</script>


<style lang="less">
    @import "../../less/admin.less";
    .delete{
        color: red
    }
    .delete:hover {
        color: red;
    }
    .el-select .el-input .el-icon-arrow-up{
        display: inline-block!important;
    }
    .el-select .el-input .el-icon-circle-close{
        float:left;
    }
</style>